import Vue from "vue";
import Router from "vue-router";
import Home from "../views/Home.vue";

Vue.use(Router);

// function propsValidator(route, component) {
//   const props = { ...route.params };
//   Object.entries(props).map(([key, prop]) => {
//     console.log(prop, key);
//     if (!(prop instanceof component.props[key].type)) {
//       props[key] = component.props[key].type(prop);
//     }
//   });
//   return props;
// }

let router = new Router({
  mode: "history",
  routes: [
    {
      path: "/",
      name: "home",
      component: Home
    },
    {
      path: "/about",
      name: "about",
      // route level code-splitting
      // this generates a separate chunk (about.[hash].js) for this route
      // which is lazy-loaded when the route is visited.
      component: () =>
        import(/* webpackChunkName: "about" */ "../views/About.vue")
    }
    // {
    //   path: "/xxx/:id",
    //   component: XXX,
    //   props(route) {
    //     return propsValidator(route, XXX);
    //   }
    // }
  ]
});

// router.beforeEach((to, from, next) => {
//   const loginPath = "/login/" + localStorage.getItem("domain");
//   if (to.path.match(/^\/login\/.+$/)) {
//     next();
//   } else {
//     if (!window.sessionStorage.getItem("token")) {
//       if (!localStorage.getItem("domain")) {
//         alert("地址出错，找不到机构！");
//       }
//       next({ path: loginPath });
//     } else {
//       next();
//     }
//   }
// });

export default router;
